; Sandwish/theme.jl

;; Sandwish theme
;;
;; for TLE 4.1
;;
;; By Isriya Paireepairit
;; based on : Eazel Theme


(let*
    ;; Update window title pixel length
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))


	;; ********* TITLE-BAR *********
	;; 6x22
        (top-left-corner-images (list (make-image "top-left-corner-d.png")
				       (make-image "top-left-corner.png")))

	;; 11x22
	(top-title-text-images (list (make-image "top-right-repeat.png")
				     (make-image "top-left-repeat.png")))

	;; 291x22
	(top-1-images (list (make-image "top-right-repeat.png")
			       (make-image "top-1.png")))

	;;
	(top-right-images (list (make-image "top-right-repeat.png")
								(make-image "top-right-repeat.png")))

	;; 6x22
	(top-right-corner-images (list (make-image "top-right-corner.png")
				      (make-image "top-right-corner.png")))


	;; ************* Button ******************
     	(menu-images (list (make-image "button-menu-d.png")
			(make-image "button-menu.png") nil
			(make-image "button-menu.png")))

	;; 22x22
	(iconify-images (list (make-image "button-min.png")
			      (make-image "button-min.png") nil
			     (make-image "button-min-active.png")))

	;; 22x22
	(maximize-images (list (make-image "button-max.png")
			       (make-image "button-max.png") nil
			       (make-image "button-max-active.png")))

	;; 22x22
	(close-images (list (make-image "button-close.png")
			    (make-image "button-close.png") nil
			    (make-image "button-close-active.png")))


	;; *********** SHADE ****************
	;; 6x22
        (top-shaded-left-corner-images (list (make-image "top-left-corner-s-d.png")
				             (make-image "top-left-corner-s.png")))

	;; 6x22
	(top-shaded-right-corner-images (list (make-image "top-right-corner-s.png")
				              (make-image "top-right-corner-s.png")))

	;; *********** LEFT-BORDER ***********

	;; 5x11
	(left-border-images (list (make-image "right-border.png")
				  (make-image "left-border.png")))


	;; ********** RIGHT-BORDER ***********
	;; 5x11
	(right-border-images (list (make-image "right-border.png")
				  (make-image "right-border.png")))


	;; ********** BOTTOM-BORDER **********

	;; 5x5
	(bottom-left-corner-images (list (make-image "bottom-left-corner-d.png")
				    (make-image "bottom-left-corner.png")))
	;; 5x5
	(bottom-left-repeat-images (list (make-image "bottom-right-repeat.png")
				    (make-image "bottom-left-repeat.png")))

	;; 220x5
	(bottom-1-images (list (make-image "bottom-1-d.png")
				    (make-image "bottom-1.png")))

	;; 5x5
	(bottom-right-repeat-images (list (make-image "bottom-right-repeat.png")
				    (make-image "bottom-right-repeat.png")))

	;; 5x5
	(bottom-right-corner-images (list (make-image "bottom-right-corner.png")
					     (make-image "bottom-right-corner.png")))


     (frame `(
	      ;; **TITLE-BAR**
              ;; top left corner
              ((background . ,top-left-corner-images)
	       (left-edge . -5)
	       (top-edge . -22)
	       (class . top-left-corner))

	      ;; window title
	      ((background . ,top-title-text-images)
	       (foreground . ,"black")
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . center)
	       (top-edge . -22)
	       (left-edge . 22)
	       (width . ,(lambda (w) (+ (title-width w) 13)))
	       (class . title))

	      ;; menu button
	      ((background . ,menu-images)
	       (top-edge . -22)
	       (left-edge . 0)
	       (class . menu-button))

	      ;; top 1
	      ((background . ,top-1-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 32)))
		(width . 291)
	       (top-edge . -22)
	       (class . title))

	      ;; top right
	      ((background . ,top-right-images)
	       (top-edge . -22)
	       (left-edge . ,(lambda (w) (+ (title-width w) 315)))
	       (right-edge . 66)
	       (class . title))

	      ;; minimize button
              ((background . ,iconify-images)
               (right-edge . 44)
               (top-edge . -22)
               (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 22)
	       (top-edge . -22)
	       (class . maximize-button))
	      
	      ;; close button
	      ((background . ,close-images)
	       (right-edge . 0)
	       (top-edge . -22)
	       (class . close-button))
	      
	      ;; top right corner
	      ((background . ,top-right-corner-images)		
	       (right-edge . -5)
	       (top-edge . -22)
	       (class . top-right-corner))
	      


	      
	      ;; **LEFT-BORDER**
      
	      ;; left border stretch
	      ((background . ,left-border-images)
	       (left-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      

	      ;; **BOTTOM-BORDER**
		;;bottom left corner
		((background . ,bottom-left-corner-images)
		(left-edge . -5)
		(bottom-edge . -5)
		(class . bottom-left-corner))


	      ;; bottom teal left grow
	    ;;  ((background . ,bottom-left-repeat-images)
	      ;; (left-edge . 0)
	     ;;  (bottom-edge . -5)
	;;	(width . 100)
	  ;;     (class . bottom-border))
	      
	      ;; bottom stretch
	      ((background . ,bottom-1-images)
	       (left-edge . 0)
	    ;;   (right-edge . 320)
		(width . 220)
	       (bottom-edge . -5)
	       (class . bottom-border))
	      
	      ;; bottom teal right grow
	      ((background . ,bottom-right-repeat-images)
	 	(left-edge . 200)      
		(right-edge . 0)
	       (bottom-edge . -5)
	       (class . bottom-border))

		;;bottom right corner
		((background . ,bottom-right-corner-images)
		(right-edge . -5)
		(bottom-edge . -5)
		(class . bottom-right-corner))


	      ;; **RIGHT-BORDER**
	      ;; right stretch
	      ((background . ,right-border-images)
	       (right-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))))
	

       (shaped-frame `(
	      ;; **TITLE-BAR**
              ;; top left corner
              ((background . ,top-shaded-left-corner-images)
	       (left-edge . -6)
	       (top-edge . -22)
	       (class . top-left-corner))
	      ;; window title
	      ((background . ,top-title-text-images)
	       (foreground . ,"black")
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . center)
	       (top-edge . -22)
	       (left-edge . 22)
	       (width . ,(lambda (w) (+ (title-width w) 13)))
	       (class . title))

	      ;; menu button
	      ((background . ,menu-images)
	       (top-edge . -22)
	       (left-edge . 0)
	       (class . menu-button))

	      ;; top 1
	      ((background . ,top-1-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 32)))
		(width . 291)
	       (top-edge . -22)
	       (class . title))

	      ;; top right
	      ((background . ,top-right-images)
	       (top-edge . -22)
	       (left-edge . ,(lambda (w) (+ (title-width w) 315)))
	       (right-edge . 66)
	       (class . title))

	      ;; minimize button
              ((background . ,iconify-images)
               (right-edge . 45)
               (top-edge . -22)
               (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 23)
	       (top-edge . -22)
	       (class . maximize-button))
	      
	      ;; close button
	      ((background . ,close-images)
	       (right-edge . 0)
	       (top-edge . -22)
	       (class . close-button))
	      
	      ;; top right corner
	      ((background . ,top-shaded-right-corner-images)		
	       (right-edge . -6)
	       (top-edge . -22)
	       (class . top-right-corner)))))

  (add-frame-style 'Sandwish
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-frame))))
  (call-after-property-changed
   'WM_NAME (lambda ()
              (rebuild-frames-with-style 'Sandwish))))
